/* 
 *  Header
 *
 *  Header is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

package ivef;

import java.util.*;
import java.text.DecimalFormat;
import java.text.DateFormat;
import java.text.SimpleDateFormat;


public class Header { 

    private String m_msgRefId; // default value is uninitialized
    private boolean m_msgRefIdPresent;
    private String m_version; // default value is uninitialized
    private boolean m_versionPresent;

    public Header() {

        m_msgRefIdPresent = false;
        m_version = "0.2.5";
        m_versionPresent = true;
    }

    public Header(Header val) {

        m_msgRefId = val.getMsgRefId();
        if (val != null) {
            m_msgRefIdPresent = true;
        }
        m_version = val.getVersion();
        if (val != null) {
            m_versionPresent = true;
        }
    }

    public boolean setMsgRefId(String val) {

        if (val.length() < 36)
          return false;
        if (val.length() > 42)
          return false;
        m_msgRefIdPresent = true;
        m_msgRefId = val;
        return true;
    }

    public String getMsgRefId() {

        return m_msgRefId;
    }

    public boolean setVersion(String val) {

        m_versionPresent = true;
        m_version = val;
        return true;
    }

    public String getVersion() {

        return m_version;
    }

    public String toXML() {

       return toXML(true);

    }

    public String toXML(boolean outputNamespace) {

        String xml = "<Header";
        if (outputNamespace) {
            xml += " xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"";
            xml += " xmlns=\"http://www.iala-to-be-confirmed.org/XMLSchema/IVEF/0.2.5\"";
        };

        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        df.setTimeZone(TimeZone.getTimeZone("UTC"));
        DecimalFormat nf = new DecimalFormat();
        nf.setMinimumFractionDigits(6);
        nf.setGroupingSize(0);

        if ( m_msgRefIdPresent ) {
            xml += " MsgRefId=\"" + encode( m_msgRefId) + "\"";
        } else { 
            return null; // not all required attributes have been set 
        } 
        if ( m_versionPresent ) {
            xml += " Version=\"" + encode( m_version) + "\"";
        } else { 
            return null; // not all required attributes have been set 
        } 
        xml += "/>\n";
        return xml;
    }

    public String toString(String lead) {

        String str = lead + "Header\n";
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss.SSS'Z'");
        df.setTimeZone(TimeZone.getTimeZone("UTC"));
        DecimalFormat nf = new DecimalFormat();
        nf.setMinimumFractionDigits(6);
        nf.setGroupingSize(0);

            str +=  lead + "    MsgRefId = " + m_msgRefId + "\n";
            str +=  lead + "    Version = " + m_version + "\n";
        return str;
    }
    public String encode( String str) {

        str = str.replaceAll("&", "&amp;");
        str = str.replaceAll("<", "&lt;");
        str = str.replaceAll(">", "&gt;");
        str = str.replaceAll("\"", "&quot;");
        return str;
    }


}
