/* 
 *  ILTrackData
 *
 *  ILTrackData is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

#import <Foundation/Foundation.h>
#import "ILPos.h"
#import "ILNavStatus.h"

//-----------------------------------------------------------
//! \brief       Class definition of ILTrackData
//!
//! DATA describing a position report of an object
//!

@interface ILTrackData : NSObject { 
    NSMutableArray *m_poss;
    BOOL m_posPresent;
    NSMutableArray *m_navStatuss;
    BOOL m_navStatusPresent;
    float m_COG;
    BOOL m_COGPresent;
    float m_estAccSOG;
    BOOL m_estAccSOGPresent;
    float m_estAccCOG;
    BOOL m_estAccCOGPresent;
    int m_id;
    BOOL m_idPresent;
    float m_length;
    BOOL m_lengthPresent;
    float m_heading;
    BOOL m_headingPresent;
    float m_ROT;
    BOOL m_ROTPresent;
    float m_SOG;
    BOOL m_SOGPresent;
    NSString *m_sourceId;
    BOOL m_sourceIdPresent;
    NSString *m_sourceName;
    BOOL m_sourceNamePresent;
    NSDate *m_updateTime;
    BOOL m_updateTimePresent;
    int m_trackStatus;
    BOOL m_trackStatusPresent;
    float m_width;
    BOOL m_widthPresent;
}

//!Remover for Pos
//!
-(BOOL) removePos:(ILPos *) val;
//!Setter for Pos
//!
-(BOOL) addPos:(ILPos *) val;
//!Getter for Pos
//!
-(ILPos *) posAt:(int) i;
//!Element counter for Pos
//!
-(int) countOfPoss;
//!Get all elements for Pos
//!
-(NSArray *) poss;
//!Remover for NavStatus
//!
-(BOOL) removeNavStatus:(ILNavStatus *) val;
//!Setter for NavStatus
//!
-(BOOL) addNavStatus:(ILNavStatus *) val;
//!Getter for NavStatus
//!
-(ILNavStatus *) navStatusAt:(int) i;
//!Element counter for NavStatus
//!
-(int) countOfNavStatuss;
//!Get all elements for NavStatus
//!
-(NSArray *) navStatuss;

/* COG:
   Course over ground  in degrees. (0-360) */
//!Setter for COG
//!
-(BOOL) setCOG:(float) val;
//!Getter for COG
//!
-(float) COG;

/* EstAccSOG:
   Estimated accuracy
   standard deviation of the calculated value 
   expressed in m/s */
//!Setter for EstAccSOG
//!
-(BOOL) setEstAccSOG:(float) val;
//!Getter for EstAccSOG
//!
-(float) estAccSOG;
//!Test for pressence of EstAccSOG
//!
-(BOOL) hasEstAccSOG;

/* EstAccCOG:
   Estimated accuracy
   standard deviation of the calculated value 
   expressed in degrees */
//!Setter for EstAccCOG
//!
-(BOOL) setEstAccCOG:(float) val;
//!Getter for EstAccCOG
//!
-(float) estAccCOG;
//!Test for pressence of EstAccCOG
//!
-(BOOL) hasEstAccCOG;

/* Id:
   The unique identification of this track. Valid from first message with TrackStatus!=Terminated to first message with TrackStatus=Terminated */
//!Setter for Id
//!
-(BOOL) setIdent:(int) val;
//!Getter for Id
//!
-(int) ident;

/* Length:
   Measured length of the target in meter */
//!Setter for Length
//!
-(BOOL) setLength:(float) val;
//!Getter for Length
//!
-(float) length;
//!Test for pressence of Length
//!
-(BOOL) hasLength;

/* Heading:
   Heading of the target in degrees */
//!Setter for Heading
//!
-(BOOL) setHeading:(float) val;
//!Getter for Heading
//!
-(float) heading;
//!Test for pressence of Heading
//!
-(BOOL) hasHeading;

/* ROT:
   Rate of turn in degrees per minute */
//!Setter for ROT
//!
-(BOOL) setROT:(float) val;
//!Getter for ROT
//!
-(float) ROT;
//!Test for pressence of ROT
//!
-(BOOL) hasROT;

/* SOG:
   Speed over ground in meters per second */
//!Setter for SOG
//!
-(BOOL) setSOG:(float) val;
//!Getter for SOG
//!
-(float) SOG;

/* SourceId:
   Unique identification of the producer  (UN/LOCODE)  in case multiple producers exist on the same LOCODE, the local competent authority can optionally addended this with a local  code (e.g. BE ANR 01 = Antwerp, 01) */
//!Setter for SourceId
//!
-(BOOL) setSourceId:(NSString *) val;
//!Getter for SourceId
//!
-(NSString *) sourceId;
//!Test for pressence of SourceId
//!
-(BOOL) hasSourceId;

/* SourceName:
   Identification of the originator of the data */
//!Setter for SourceName
//!
-(BOOL) setSourceName:(NSString *) val;
//!Getter for SourceName
//!
-(NSString *) sourceName;

/* UpdateTime:
   Date and time in UTC format (YYYY-MM-DDThh:mm:ss.sssZ) (subset of ISO 8601)  this position was measured. */
//!Setter for UpdateTime
//!
-(BOOL) setUpdateTime:(NSDate *) val;
//!Getter for UpdateTime
//!
-(NSDate *) updateTime;

/* TrackStatus:
   1 = Updated, (sensors are updating the track)
   2 = Coasted, (no sensor is updating the track)
   3 = Dropped */
//!Setter for TrackStatus
//!
-(BOOL) setTrackStatus:(int) val;
//!Getter for TrackStatus
//!
-(int) trackStatus;

/* Width:
   Measured Width of the target in meter */
//!Setter for Width
//!
-(BOOL) setWidth:(float) val;
//!Getter for Width
//!
-(float) width;
//!Test for pressence of Width
//!
-(BOOL) hasWidth;
//!Set attributes by providing a key/value dictionary
//!

-(BOOL) setAttributes:(NSDictionary *)attributeDict;
//!Get attributes as a key/value dictionary
//!
-(NSDictionary *) attributes;
//!Get a XML representation of this class
//!returns nil if not all required fields are set
//!
-(NSString *) XML;
//!Get a string representation of this class
//!
-(NSString *) stringValue;
-(NSString *) stringValueWithLead:(NSString *) lead;
//!Helper routine to encode any string to an XML escaped string
//!
-(NSString *) encode: (NSString *) input;

@end



