/* 
 *  Item
 *
 *  Item is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

#ifndef __ITEM_H__
#define __ITEM_H__

#include <QObject>
#include <QString>
#include <QDateTime>

class XmlStreamReader;

namespace ivef {

//-----------------------------------------------------------
//! \brief       Class definition of Item
//!
//! 
//!
class Item : public QObject { 
    Q_OBJECT

public:
    //! constructor
    //!
    Item();
    //! constructor for parser function
    //!
    Item(XmlStreamReader&);
    //! copy constructor
    //!
    Item(const Item&);
    //! = operator
    //!
    Item & operator=(const Item& val);
    //! == operator
    //!
    bool operator==(const Item& val);
    //! sets the DataSelector: Describes requested Object data element, possible values:\n
    //! 1 = TrackData\n
    //! 2 = VesselData\n
    //! 3 = VoyageData
    //!
    bool setDataSelector(int val);

    //! gets the DataSelector: Describes requested Object data element, possible values:\n
    //! 1 = TrackData\n
    //! 2 = VesselData\n
    //! 3 = VoyageData
    //!
    //! \return     int
    //!
    int getDataSelector() const;

    //! sets the FieldSelector: Selected field. Can be 'all' or one of the items of object data TrackData, VesselData  or VoyageData, to be changed into an enumeration of strings once these have been fixed
    //!
    bool setFieldSelector(QString val);

    //! gets the FieldSelector: Selected field. Can be 'all' or one of the items of object data TrackData, VesselData  or VoyageData, to be changed into an enumeration of strings once these have been fixed
    //!
    //! \return     QString
    //!
    QString getFieldSelector() const;

    //! generates XML of this object including attributes and child elements
    //! returns QString::null if not all required elements are available
    //! If null returned check lastError() for problem description
    //!
    //! \return     QString
    const QString& toXML(bool outputNamespace = true);

    //! generates output of this object including attributes and child elements
    //!
    //! \return     QString
    QString toString() const;

    //! generates output of this object including attributes and child elements
    //!
    //! \return     QString
    QString toString(QString lead) const;

    //! return last error found in toXML function
    //!
    //! \return     QString
    const QString& lastError() const;

    //! return changed 
    //!
    //! \return     bool
    const bool& changed() const;

    //! return store 
    //!
    //! \return     QString
    const QString& store() const;


private:
    int m_dataSelector;
    bool m_dataSelectorPresent;
    QString m_fieldSelector;
    bool m_fieldSelectorPresent;
    QString m_lastError; 
    bool m_changed; 
    QString m_store;
}; 
} //end ns

#endif
