/* 
 *  ObjectData
 *
 *  ObjectData is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

#ifndef __OBJECTDATA_H__
#define __OBJECTDATA_H__

#include <QObject>
#include <QString>
#include <QDateTime>
#include "IVEFTrackData.h"
#include "IVEFVesselData.h"
#include "IVEFVoyageData.h"
#include "IVEFTaggedItem.h"

class XmlStreamReader;

namespace ivef {

//-----------------------------------------------------------
//! \brief       Class definition of ObjectData
//!
//! DATA regarding an object in the supliers domain, contains at least 1 one of the sub elements (TrackData, VesselData, VoyageData)
//!
class ObjectData : public QObject { 
    Q_OBJECT

public:
    //! constructor
    //!
    ObjectData();
    //! constructor for parser function
    //!
    ObjectData(XmlStreamReader&);
    //! copy constructor
    //!
    ObjectData(const ObjectData&);
    //! = operator
    //!
    ObjectData & operator=(const ObjectData& val);
    //! == operator
    //!
    bool operator==(const ObjectData& val);
    //! sets the TrackData
    //!
    bool setTrackData(const TrackData& val);

    //! gets the TrackData
    //!
    //! \return     TrackData
    //!
    const TrackData& getTrackData() const;

    //! returns true if TrackDatais used (optional field).
    //!
    //! \return     bool
    bool hasTrackData() const;

    //! removes a VesselData.
    //!
    bool removeVesselData(const VesselData& val);

    //! adds a VesselData.
    //!
    bool addVesselData(const VesselData& val);

    //! gets the i-th VesselData.
    //!
    const VesselData& getVesselDataAt(int i) const;

    //!              return the number of VesselData objects.
    //!
    //! \return     int
    int countOfVesselDatas() const;

    //! removes a VoyageData.
    //!
    bool removeVoyageData(const VoyageData& val);

    //! adds a VoyageData.
    //!
    bool addVoyageData(const VoyageData& val);

    //! gets the i-th VoyageData.
    //!
    const VoyageData& getVoyageDataAt(int i) const;

    //!              return the number of VoyageData objects.
    //!
    //! \return     int
    int countOfVoyageDatas() const;

    //! removes a TaggedItem.
    //!
    bool removeTaggedItem(const TaggedItem& val);

    //! adds a TaggedItem.
    //!
    bool addTaggedItem(const TaggedItem& val);

    //! gets the i-th TaggedItem.
    //!
    const TaggedItem& getTaggedItemAt(int i) const;

    //!              return the number of TaggedItem objects.
    //!
    //! \return     int
    int countOfTaggedItems() const;

    //! generates XML of this object including attributes and child elements
    //! returns QString::null if not all required elements are available
    //! If null returned check lastError() for problem description
    //!
    //! \return     QString
    const QString& toXML(bool outputNamespace = true);

    //! generates output of this object including attributes and child elements
    //!
    //! \return     QString
    QString toString() const;

    //! generates output of this object including attributes and child elements
    //!
    //! \return     QString
    QString toString(QString lead) const;

    //! return last error found in toXML function
    //!
    //! \return     QString
    const QString& lastError() const;

    //! return changed 
    //!
    //! \return     bool
    const bool& changed() const;

    //! return store 
    //!
    //! \return     QString
    const QString& store() const;


private:
    TrackData m_trackData;
    bool m_trackDataPresent;
    QList<VesselData> m_vesselDatas;
    QList<VoyageData> m_voyageDatas;
    QList<TaggedItem> m_taggedItems;
    QString m_lastError; 
    bool m_changed; 
    QString m_store;
}; 
} //end ns

#endif
