/* 
 *  ServerStatus
 *
 *  ServerStatus is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Foobar is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY ); without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 **********************************************************************************
 *  WARNING: THIS CODE WAS GENERATED DO NOT MODIFY, CHANGE THE XSD INSTEAD
 *  Generated by schema2code on Tue Jun 14 15:34:00 2016.
 **********************************************************************************
 *  Copyright 2010
 *
 */

#ifndef __SERVERSTATUS_H__
#define __SERVERSTATUS_H__

#include <QObject>
#include <QString>
#include <QDateTime>

class XmlStreamReader;

namespace ivef {

//-----------------------------------------------------------
//! \brief       Class definition of ServerStatus
//!
//! DATA describing the status of the server (full/available)
//!
class ServerStatus : public QObject { 
    Q_OBJECT

public:
    //! constructor
    //!
    ServerStatus();
    //! constructor for parser function
    //!
    ServerStatus(XmlStreamReader&);
    //! copy constructor
    //!
    ServerStatus(const ServerStatus&);
    //! = operator
    //!
    ServerStatus & operator=(const ServerStatus& val);
    //! == operator
    //!
    bool operator==(const ServerStatus& val);
    //! sets the ContactIdentity: reference to the identity associated with this service
    //!
    bool setContactIdentity(QString val);

    //! gets the ContactIdentity: reference to the identity associated with this service
    //!
    //! \return     QString
    //!
    QString getContactIdentity() const;

    //! returns true if ContactIdentityis used (optional field).
    //!
    //! \return     bool
    bool hasContactIdentity() const;

    //! sets the Details: Details of status
    //!
    bool setDetails(QString val);

    //! gets the Details: Details of status
    //!
    //! \return     QString
    //!
    QString getDetails() const;

    //! returns true if Detailsis used (optional field).
    //!
    //! \return     bool
    bool hasDetails() const;

    //! sets the Status: Status of the server (ok /  not ok)
    //!
    bool setStatus(bool val);

    //! gets the Status: Status of the server (ok /  not ok)
    //!
    //! \return     bool
    //!
    bool getStatus() const;

    //! generates XML of this object including attributes and child elements
    //! returns QString::null if not all required elements are available
    //! If null returned check lastError() for problem description
    //!
    //! \return     QString
    const QString& toXML(bool outputNamespace = true);

    //! generates output of this object including attributes and child elements
    //!
    //! \return     QString
    QString toString() const;

    //! generates output of this object including attributes and child elements
    //!
    //! \return     QString
    QString toString(QString lead) const;

    //! return last error found in toXML function
    //!
    //! \return     QString
    const QString& lastError() const;

    //! return changed 
    //!
    //! \return     bool
    const bool& changed() const;

    //! return store 
    //!
    //! \return     QString
    const QString& store() const;


private:
    QString m_contactIdentity;
    bool m_contactIdentityPresent;
    QString m_details;
    bool m_detailsPresent;
    bool m_status;
    bool m_statusPresent;
    QString m_lastError; 
    bool m_changed; 
    QString m_store;
}; 
} //end ns

#endif
